# SPDX-License-Identifier: AGPL-3.0-or-later

# to start the script the variables
# AGENT_JAR, BOOTSTRAP_JAR, BOOTSTRAP_JAR and CLIENT_JAR
# have to be set to their jar files

AGENT_ARGS=""
ARGS_START=1
CLIENT_ARGS=()
NO_CLIENT=""
NO_SERVER=""
NO_ADD_DEFAULT_ARGS=""

if test " $JAVA" = " "; then JAVA=java; fi

while test $ARGS_START -le $#; do
  if test "${@:$ARGS_START:1}" = "--help"; then
    ((ARGS_START++))
    if test "{@:$ARGS_START:1}" = "agent" ; then
      "$JAVA" "-javaagent:$AGENT_JAR=agent-help"
    elif test "{@:$ARGS_START:1}" = "bootstrap" ; then
      "$JAVA" -cp "$BOOTSTRAP_JAR" de.hechler.patrick.profiler.Main bootstrap-help
    elif test '(' "{@:$ARGS_START:1}" = "server" ')' -o '(' "{@:$ARGS_START:1}" = "daemon" ')' ; then
      "$JAVA" "-javaagent:$AGENT_JAR=daemon.help" \
            "-Xbootclasspath/a:$BOOTSTRAP_JAR" \
            "-Xbootclasspath/a:$SERVER_JAR"
    elif test "{@:$ARGS_START:1}" = "client" ; then
      "$JAVA" \
        -cp "$CLIENT_JAR" \
        de.hechler.patrick.profiler.client.Client \
          --help
    else
      echo -n "$0 help:
  Usage: $(basename $0) [OPTIONS...] <JVM_ARGS...>
         $(basename $0) [OPTIONS...] --only-client [CLIENT_ARGS...]
  Options:
    --help
      show this message and exit
    --help agent
      show the java agents help message and exit
    --help bootstrap
      show the boootstrap library help message and exit
    --help server
    --help daemon
      show the server library help message and exit
    --help client
      show the client programs help message and exit
    --bootstrap [BOOTSTRAP_ARGS...]
      invoke the boostraps Main and pass all following arguments to it
      note that when this option is set the agent will not be attached to the JVM
    --agent <AGENT_OPTS>
      pass AGENT_OPTS to the java agent
      to pass multiple options to the agent use a ',' to seperate them
      to pass options to the server insert a 'daemon.' before the option
    --no-client
      do not start a client
      this will lead to all --client options to be ignored
    --no-server
      do not start a server
      do not add the server jar and do not
      add do not add default arguments to start it
    --no-defaults
      do not add default options/arguments
    --only-client [CLIENT_ARGS...]
      pass CLIENT_ARGS to the client
      this prevents the execution of the profiler
    --client <CLIENT_ARG>
    --client1 <CLIENT_ARG>
      pass CLIENT_ARG to the client
      if --client is specified multiple times the client arguments
      are passed in the same order as in the argument list of the script
    --client2 <CLIENT_ARG_0> <CLIENT_ARG_1>
      pass CLIENT_ARG_0 and CLIENT_ARG_1 to the client
      same as --client CLIENT_ARG_0 --client CLIENT_ARG_1
    --client3 <CLIENT_ARG_0> <CLIENT_ARG_1> <CLIENT_ARG_2>
      pass CLIENT_ARG_0, CLIENT_ARG_1 and CLIENT_ARG_2 to the client
      same as --client2 CLIENT_ARG_0 CLIENT_ARG_1 --client CLIENT_ARG_2
    <JVM_ARGS...>
      pass these arguments to the JVM in the same order
      these arguments are passed behind the arguments generated by this script
"
    fi
    exit 1
  elif test "$1" = "--bootstrap"; then
    ((ARGS_START++))
    exec java -cp "$BOOTSTRAP_JAR" \
      de.hechler.patrick.profiler.Main "${@:$ARGS_START}"
  elif test "${@:$ARGS_START:1}" = "--agent"; then
    ((ARGS_START++))
    if test " $AGENT_ARGS" = " "; then
      AGENT_ARGS="=${@:$ARGS_START:1}"
    else
      AGENT_ARGS="$AGENT_ARGS,${@:$ARGS_START:1}"
    fi
    ((ARGS_START++))
  elif test '(' "${@:$ARGS_START:1}" = "--client" ')' -o '(' "${@:$ARGS_START:1}" = "--client1" ')'; then
    ((ARGS_START++))
    CLIENT_ARGS=("${CLIENT_ARGS[@]}" "${@:$ARGS_START:1}")
    ((ARGS_START++))
  elif test "${@:$ARGS_START:1}" = "--client2"; then
    ((ARGS_START++))
    CLIENT_ARGS=("${CLIENT_ARGS[@]}" "${@:$ARGS_START:2}")
    ((ARGS_START+=2))
  elif test "${@:$ARGS_START:1}" = "--client3"; then
    ((ARGS_START++))
    CLIENT_ARGS=("${CLIENT_ARGS[@]}" "${@:$ARGS_START:3}")
    ((ARGS_START+=3))
  elif test "${@:$ARGS_START:1}" = "--no-defaults"; then
    NO_ADD_DEFAULT_ARGS="yes"
    ((ARGS_START++))
  elif test "${@:$ARGS_START:1}" = "--no-client"; then
    NO_CLIENT="yes"
    ((ARGS_START++))
  elif test "${@:$ARGS_START:1}" = "--no-server"; then
    NO_SERVER="yes"
    ((ARGS_START++))
  elif test "${@:$ARGS_START:1}" = "--only-client"; then
    ((ARGS_START++))
    exec "$JAVA" \
      -cp "$CLIENT_JAR" \
      de.hechler.patrick.profiler.client.Client \
        "${CLIENT_ARGS[@]}" \
        "${@:$ARGS_START}"
  else
    if test " $NO_SERVER" = " " ; then
      if test " $NO_CLIENT" = " " ; then
        if test " $NO_ADD_DEFAULT_ARGS" = " "; then
          if test " $AGENT_ARGS" = " "; then
            AGENT_ARGS="=daemon.print-client-args,daemon.wait2"
          else
            AGENT_ARGS="$AGENT_ARGS,daemon.print-client-args,daemon.wait2"
          fi
        fi
        DEF_CARGS=( "$("$JAVA" \
          "-javaagent:$AGENT_JAR$AGENT_ARGS" \
          "-Xbootclasspath/a:$BOOTSTRAP_JAR" \
          "-Xbootclasspath/a:$SERVER_JAR" \
          "${@:$ARGS_START}" | head -1 &)" )
        if test " $NO_ADD_DEFAULT_ARGS" != " "; then
          DEF_CARGS=( )
        fi
        exec "$JAVA" \
          -cp "$CLIENT_JAR" \
          de.hechler.patrick.profiler.client.Client \
          "${DEF_CARGS[@]}" \
          "${CLIENT_ARGS[@]}"
      else
        exec "$JAVA" \
          "-javaagent:$AGENT_JAR$AGENT_ARGS" \
          "-Xbootclasspath/a:$BOOTSTRAP_JAR" \
          "-Xbootclasspath/a:$SERVER_JAR" \
          "${@:$ARGS_START}"
      fi
    elif test " $NO_CLIENT" = " " ; then
      set +e # continue even if the profiled program fails
      OLD_MOD_TIME="$(stat '--printf=%Y' patr-java-profiler-output.data || echo -n 0)"
      "$JAVA" \
        "-javaagent:$AGENT_JAR$AGENT_ARGS" \
        "-Xbootclasspath/a:$BOOTSTRAP_JAR" \
        "${@:$ARGS_START}"
      EXIT_NUM=$?
      NEW_MOD_TIME="$(stat '--printf=%Y' patr-java-profiler-output.data || echo -n 0)"
      if test '(' $NEW_MOD_TIME -gt $OLD_MOD_TIME ')' -o '(' '(' $NEW_MOD_TIME = 0 ')'  -a '(' -f patr-java-profiler-output.data ')' ')' ; then
        "$JAVA" \
          -cp "$CLIENT_JAR" \
          de.hechler.patrick.profiler.client.Client \
            --file patr-java-profiler-output.data \
            "${CLIENT_ARGS[@]}"
        OEXUT_NUM=$?
        if test $EXIT_NUM -lt $OEXUT_NUM; then
          EXIT_NUM=$OEXUT_NUM
        fi
      fi
      exit $EXIT_NUM
    else
      exec "$JAVA" \
        "-javaagent:$AGENT_JAR$AGENT_ARGS" \
        "-Xbootclasspath/a:$BOOTSTRAP_JAR" \
        "${@:$ARGS_START}"
    fi
  fi
done

echo -n "missing additional arguments!
you need to specify what you want to profile!

" >&2
exec $0 --help >&2
